%global module_version 0.9929

Summary:        Object oriented versions for all Perl
Name:           perl-version
Version:        0.99.29
Release:        5%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/version
Source0:        https://cpan.metacpan.org/authors/id/L/LE/LEONT/version-%{module_version}.tar.gz
# Build
BuildRequires:  gcc make findutils
BuildRequires:  perl-generators perl-interpreter perl-devel perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Temp) >= 0.13
BuildRequires:  perl(strict)
# Runtime
BuildRequires:  perl(B) perl(Carp) perl(constant) perl(if)
BuildRequires:  perl(locale) perl(overload) perl(POSIX) perl(UNIVERSAL)
BuildRequires:  perl(warnings) perl(warnings::register) perl(XSLoader)
# For tests
BuildRequires:  perl(base) perl(lib) perl(Data::Dumper)
BuildRequires:  perl(File::Basename) perl(File::Spec) perl(IO::Handle) perl(List::Util)
BuildRequires:  perl(Test::Harness)
BuildRequires:  perl(Test::More) >= 0.45

Requires:       perl(B) perl(Carp) perl(locale)
Requires:       perl(UNIVERSAL) perl(warnings) perl(XSLoader)
%{?perl_default_filter}
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}perl\\(version::vxs\\)
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

%description
Object oriented versions for all Perl releases from 5.6.2 onward.  Replaces
the core version code for all Perl releases from 5.10.0 onwards.
YOU SHOULD INSTALL THIS RELEASE WHEN USING VERSION OBJECTS IN PERL 5.10.0.
There was a bug caused by objects serialized by YAML that will cause Perl
5.10.0 to segfault.  As long as some module calls 'use version', then the
replacement code will take effect and Perl will not crash.

Please read the POD documentation for usage/details.  See the CHANGES file
for full details of all changes to the module behavior.


%prep
%autosetup -n version-%{module_version}

# Help to recognise the Perl scripts
for file in t/*.t t/survey_locales; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "${file}"
    chmod +x "${file}"
done
perl -MConfig -i -pe 's/\A#!.*perl/$Config{startperl}/' t/*.pm


%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" UNINST=0 NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}


%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -size 0 -delete
%{_fixperms} %{buildroot}/*


%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
make test


%files
%doc CHANGES README
%doc %{perl_vendorarch}/version.pod
%dir %{perl_vendorarch}/version/
%doc %{perl_vendorarch}/version/Internals.pod
%{perl_vendorarch}/auto/version/
%{perl_vendorarch}/version.pm
%{perl_vendorarch}/version/vpp.pm
%{perl_vendorarch}/version/vxs.pm
%{perl_vendorarch}/version/regex.pm
%{_mandir}/man3/version.3pm*
%{_mandir}/man3/version::Internals.3pm*


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.99.29-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.99.29-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.99.29-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.99.29-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Aug 04 2022 rockerzhu <rockerzhu@tencent.com> - 0.99.29-1
- Initial build
